Unit Av17r_p;
interface
uses
SysUtils, Math, { Delphi }
LStruct, Lfunc, utav10_p;

procedure Av17r(N :Integer; var SX :Array of Real; INCX :Integer;
                var SY :Array of Real; INCY :Integer;
                var IERR :Integer);
implementation

procedure Av17r(N :Integer; var SX :Array of Real; INCX :Integer;
                var SY :Array of Real; INCY :Integer;
                var IERR :Integer);
var                
I,IX,IY,M,MP1 :Integer;
label
_10,_20,_30,_40,_50,_60,_70;
begin
if ( N <= 0 ) 
 then goto _60;
IERR := 0;
if ( INCX = 1) and (INCY = 1 ) 
 then goto _20;
IX := Trunc( 1 + ((INCX - Abs(INCX))/2)*(1 - N) );
IY := Trunc( 1 + ((INCY - Abs(INCY))/2)*(1 - N) );
for I:=1 to N do
 begin
  SY[IY-1] := SX[IX-1];
  IX := IX + INCX;
  IY := IY + INCY;
_10:
 end;
goto _70;
_20:
M := (N Mod 7);
if ( M = 0 ) 
 then goto _40;
for I:=1 to M do
 begin
  SY[I-1] := SX[I-1];
_30:
 end;
if ( N < 7 ) 
 then goto _70;
_40:
MP1 := M + 1;
I := MP1;
while ( I<=N ) do
 begin
  SY[I-1] := SX[I-1];
  SY[I+0] := SX[I+0];
  SY[I+1] := SX[I+1];
  SY[I+2] := SX[I+2];
  SY[I+3] := SX[I+3];
  SY[I+4] := SX[I+4];
  SY[I+5] := SX[I+5];
_50:
  inc(I,7);
 end;
goto _70;
_60:
IERR := 65;
UTAV10(IERR,22);
_70:
end;

end.
